/*
 *
 *                This source code is part of
 *                    ******************
 *                    ***   Pteros   ***
 *                    ******************
 *                 molecular modeling library
 *
 * Copyright (c) 2009-2013, Semen Yesylevskyy
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of Artistic License:
 *
 * Please note, that Artistic License is slightly more restrictive
 * then GPL license in terms of distributing the modified versions
 * of this software (they should be approved first).
 * Read http://www.opensource.org/licenses/artistic-license-2.0.php
 * for details. Such license fits scientific software better then
 * GPL because it prevents the distribution of bugged derivatives.
 *
*/

#ifndef CONSUMER_H
#define CONSUMER_H

#include "pteros/analysis/consumer_base.h"
#include "pteros/analysis/jump_remover.h"
#include "pteros/core/pteros_error.h"

namespace pteros {

/** Normal consumer
  */
class Consumer: public Consumer_base {
public:
    Consumer(Trajectory_processor* pr): Consumer_base(pr){}

    Jump_remover jump_remover;

protected:
    virtual void process_frame_data(Frame& data);
    virtual void process_frame_handler(const Frame_info& info);
};

}

#endif
